; LINKPORT.H v0.1 ALPHA
; Z80 ASM LinkPort routines for TI graphing calculators
; by Randy Gluvna (gluvna@home.com)
; http://members.home.com/gluvna
;
;------------------------------------------------------
; Descriptions of functions:
;
; RECEIVE_BYTE - Receive byte from a device
;                Receives: void
;                Returns: A - byte received
;
; SEND_BYTE - Send byte to a device
;             Receives: A - byte to send
;             Returns: void
;
; SEND_ZT_STR - Send zero-terminated string to a device
;               Receives: HL - pointer to string
;               Returns: HL - pointer to end of string
;------------------------------------------------------
;

RECEIVE_BYTE:
        LD      B,008H          
R0:
        LD      DE,0FFFFH       
        JR      R2              
R1:
        IN      A,(PORT)        
        AND     003H            
        RET     Z               
        CP      003H            
        JR      NZ,R3           
        IN      A,(PORT)        
        AND     003H            
        RET     Z               
        CP      003H            
        JR      NZ,R3           
R2:
        DEC     DE              
        LD      A,D             
        OR      E               
        JR      NZ,R1           
        RET                     
R3:
        SUB     002H            
        JR      NC,R8           
        LD      A,0D4H          
        OUT     (PORT),A        
        RR      C               
        LD      DE,0FFFFH       
R4:
        IN      A,(PORT)        
        AND     003H            
        CP      002H            
        JR      Z,R5            
        DEC     DE              
        LD      A,D             
        OR      E               
        JR      NZ,R4           
        RET                     
R5:
        LD      A,0C0H          
        OUT     (PORT),A        
        LD      D,004H          
R6:
        DEC     D               
        JR      Z,R7            
        IN      A,(PORT)        
        AND     003H            
        CP      003H            
        JR      NZ,R6           
R7:
        DJNZ    R0              
        LD      A,C             
        RET                     
R8:
        LD      A,0E8H          
        OUT     (PORT),A        
        RR      C               
        LD      DE,0FFFFH       
R9:
        IN      A,(PORT)        
        AND     003H            
        CP      001H            
        JR      Z,R5            
        DEC     DE              
        LD      A,D             
        OR      E               
        JR      NZ,R9           
        RET                     

SEND_BYTE:
        LD      C,A             
        LD      B,008H          
S0:
        LD      DE,0FFFFH       
        RR      C               
        JR      NC,S1           
        LD      A,0E8H          
        JR      S2              
S1:
        LD      A,0D4H          
S2:
        OUT     (PORT),A        
S3:
        IN      A,(PORT)        
        AND     003H            
        JR      Z,S4            
        IN      A,(PORT)        
        AND     003H            
        JR      Z,S4            
        DEC     DE              
        LD      A,D             
        OR      E               
        JR      NZ,S3           
        RET                     
S4:
        LD      A,0C0H          
        OUT     (PORT),A        
        LD      DE,0FFFFH       
S5:
        DEC     DE              
        LD      A,D             
        OR      E               
        RET     Z               
        IN      A,(PORT)        
        AND     003H            
        CP      003H            
        JR      NZ,S5           
        DJNZ    S0              
        RET                     

SEND_ZT_STR:
        LD      A,(HL)
        OR      A
        RET     Z
        CALL    SEND_BYTE
        INC     HL
        JR      SEND_ZT_STR
