; RTerm 82 v0.4
; by Randy Gluvna
; gluvna@home.com
; http://members.home.com/gluvna

#INCLUDE "TI82.H"
#INCLUDE "KEYS.INC"
PORT = 000H

.ORG START_ADDR

.DB "RTerm v0.4",0

INIT:
        ROM_CALL(CLEARTEXT_F)
MENU:
        ROM_CALL(CLEARLCD)
        LD HL,$0000
        LD (CURSOR_ROW),HL
        LD HL,STRING_TITLE
        SET 3,(IY+05)
        ROM_CALL(D_ZT_STR)
        LD HL,$0001
        LD (CURSOR_ROW),HL
        LD HL,STRING_AUTHOR
        RES 3,(IY+05)
        ROM_CALL(D_ZT_STR)
        LD HL,$0003
        LD (CURSOR_ROW),HL
        LD HL,STRING_MENU
        ROM_CALL(D_ZT_STR)
MENU_WAIT:
        CALL GET_KEY
        CP G_1
        JR Z,TERMINAL
        CP G_2
        JP Z,SETTINGS
        CP G_3
        RET Z
        CP G_MODE
        RET Z
        JR MENU_WAIT
TERMINAL:
        ROM_CALL(CLEARLCD)
        LD HL,$0000
        LD (CURSOR_X),HL
TERM_WAIT:        
        LD HL,TEXT_MEM
        BIT 4,(HL)
        JP NZ,KEY_VARS
        LD HL,$0F00
        LD (CURSOR_ROW),HL
        LD A,$23
        LD HL,TEXT_MEM
        BIT 6,(HL)
        CALL NZ,ALPHA
        ROM_CALL(TX_CHARPUT)
        JR CONTINUE
ALPHA:
        BIT 5,(HL)
        JR NZ,UPPER
        LD A,$DC
        RET
UPPER:
        LD A,$DB
        RET
CONTINUE:
        IN A,(0)
        AND 3
        CP 3
        JP NZ,RECEIVE
        CALL GET_KEY
        LD HL,TEXT_MEM
        CP 55
        JP Z,MENU
        CP 48
        JP Z,KEY_ALPHA
        CP 2
        JP Z,KEY_BACKSPACE
        CP 17
        JP Z,SPACE
        CP 9
        JP Z,KEY_ENTER
        CP 15
        JP Z,CLEAR
        CP 23
        JP Z,KEY_VARS
        CP 47
        JP Z,KEY_A
        CP 39
        JP Z,KEY_B
        CP 31
        JP Z,KEY_C
        CP 46
        JP Z,KEY_D
        CP 38
        JP Z,KEY_E
        CP 30
        JP Z,KEY_F
        CP 22
        JP Z,KEY_G
        CP 14
        JP Z,KEY_H
        CP 45
        JP Z,KEY_I
        CP 37
        JP Z,KEY_J
        CP 29
        JP Z,KEY_K
        CP 21
        JP Z,KEY_L
        CP 13
        JP Z,KEY_M
        CP 44
        JP Z,KEY_N
        CP 36
        JP Z,KEY_O
        CP 28
        JP Z,KEY_P
        CP 20
        JP Z,KEY_Q
        CP 12
        JP Z,KEY_R
        CP 43
        JP Z,KEY_S
        CP 35
        JP Z,KEY_T
        CP 27
        JP Z,KEY_U
        CP 19
        JP Z,KEY_V
        CP 11
        JP Z,KEY_W
        CP 42
        JP Z,KEY_X
        CP 34
        JP Z,KEY_Y
        CP 26
        JP Z,KEY_Z
        CP 18
        JP Z,KEY_EXCLAMATION
        CP 10
        JP Z,KEY_QUOTES
        CP 33
        JP Z,KEY_SPACE
        CP 25
        JP Z,KEY_COLON
        CP 17
        JP Z,KEY_QUESTION
        JP TERM_WAIT
RECEIVE:
        CALL RECEIVE_BYTE
        RES 7,A
        CP 8
        JP Z,BACKSPACE
        CP 10
        JP Z,TERM_WAIT
        CP 12
        JP Z,CLEAR
        CP 13
        JP Z,JUMP_NEWLINE
        JP PRINT_CHAR
KEY_ALPHA:
        BIT 6,(HL)
        JR Z,SET_ALPHA
        BIT 5,(HL)
        JR Z,SET_UPPER
        RES 6,(HL)
        RES 5,(HL)
        JP TERM_WAIT
SET_ALPHA:
        SET 6,(HL)
        JP Z,TERM_WAIT
SET_UPPER:
        SET 5,(HL)
        JP Z,TERM_WAIT
KEY_ENTER:
        LD A,13
        CALL SEND_BYTE
        LD HL,TEXT_MEM
        BIT 7,(HL)
        JP NZ,JUMP_NEWLINE
        JP TERM_WAIT
KEY_BACKSPACE:
        LD A,8
        CALL SEND_BYTE
        LD HL,TEXT_MEM
        BIT 7,(HL)
        JP NZ,BACKSPACE
        JP TERM_WAIT
SPACE:
        LD A,$20
        JP SEND
KEY_VARS:
        LD HL,TEXT_MEM
        SET 4,(HL)
        IN A,(0)
        AND 3
        CP 3
        JP NZ,RECEIVE
        LD HL,$0F00
        LD (CURSOR_ROW),HL
        LD A,(TEXT_MEM+1)
        ROM_CALL(TX_CHARPUT)
        CALL GET_KEY
        CP 4
        JP Z,INCREMENT
        CP 1
        JP Z,DECREMENT
        CP 48
        JP Z,QUIT_VARS
        CP 54
        JP Z,SEND_VARS
        CP 55
        JP Z,QUIT_VARS
        CP 23
        JP Z,QUIT_VARS
        JR KEY_VARS
INCREMENT:
        LD A,(TEXT_MEM+1)
        CP 127
        JR Z,KEY_VARS
        LD HL,TEXT_MEM+1
        INC (HL)
        JR KEY_VARS
DECREMENT:
        LD A,(TEXT_MEM+1)
        OR A
        JR Z,KEY_VARS
        LD HL,TEXT_MEM+1
        DEC (HL)
        JR KEY_VARS
SEND_VARS:
        LD A,(TEXT_MEM+1)
        JP SEND
QUIT_VARS:
        LD HL,TEXT_MEM
        RES 4,(HL)
        JP TERM_WAIT
KEY_A:
        BIT 5,(HL)
        JR Z,LOWER_A
        LD A,$41
        JP SEND
LOWER_A:
        LD A,$61
        JP SEND
KEY_B:
        BIT 5,(HL)
        JR Z,LOWER_B
        LD A,$42
        JP SEND
LOWER_B:
        LD A,$62
        JP SEND
KEY_C:
        BIT 5,(HL)
        JR Z,LOWER_C
        LD A,$43
        JP SEND
LOWER_C:
        LD A,$63
        JP SEND
KEY_D:
        BIT 5,(HL)
        JR Z,LOWER_D
        LD A,$44
        JP SEND
LOWER_D:
        LD A,$64
        JP SEND
KEY_E:
        BIT 5,(HL)
        JR Z,LOWER_E
        LD A,$45
        JP SEND
LOWER_E:
        LD A,$65
        JP SEND
KEY_F:
        BIT 5,(HL)
        JR Z,LOWER_F
        LD A,$46
        JP SEND
LOWER_F:
        LD A,$66
        JP SEND
KEY_G:
        BIT 5,(HL)
        JR Z,LOWER_G
        LD A,$47
        JP SEND
LOWER_G:
        LD A,$67
        JP SEND
KEY_H:
        BIT 6,(HL)
        JR Z,NUM_H
        BIT 5,(HL)
        JR Z,LOWER_H
        LD A,$48
        JP SEND
NUM_H:
        LD A,$5E
        JP SEND
LOWER_H:
        LD A,$68
        JP SEND
KEY_I:
        BIT 5,(HL)
        JR Z,LOWER_I
        LD A,$49
        JP SEND
LOWER_I:
        LD A,$69
        JP SEND
KEY_J:
        BIT 6,(HL)
        JR Z,NUM_J
        BIT 5,(HL)
        JR Z,LOWER_J
        LD A,$4A
        JP SEND
NUM_J:
        LD A,$2C
        JP SEND
LOWER_J:
        LD A,$6A
        JP SEND
KEY_K:
        BIT 6,(HL)
        JR Z,NUM_K
        BIT 5,(HL)
        JR Z,LOWER_K
        LD A,$4B
        JP SEND
NUM_K:
        LD A,$28
        JP SEND
LOWER_K:
        LD A,$6B
        JP SEND
KEY_L:
        BIT 6,(HL)
        JR Z,NUM_L
        BIT 5,(HL)
        JR Z,LOWER_L
        LD A,$4C
        JP SEND
NUM_L:
        LD A,$29
        JP SEND
LOWER_L:
        LD A,$6C
        JP SEND
KEY_M:
        BIT 6,(HL)
        JR Z,NUM_M
        BIT 5,(HL)
        JR Z,LOWER_M
        LD A,$4D
        JP SEND
NUM_M:
        LD A,$2F
        JP SEND
LOWER_M:
        LD A,$6D
        JP SEND
KEY_N:
        BIT 5,(HL)
        JR Z,LOWER_N
        LD A,$4E
        JP SEND
LOWER_N:
        LD A,$6E
        JP SEND
KEY_O:
        BIT 6,(HL)
        JR Z,NUM_O
        BIT 5,(HL)
        JR Z,LOWER_O
        LD A,$4F
        JP SEND
NUM_O:
        LD A,$37
        JP SEND
LOWER_O:
        LD A,$6F
        JP SEND
KEY_P:
        BIT 6,(HL)
        JR Z,NUM_P
        BIT 5,(HL)
        JR Z,LOWER_P
        LD A,$50
        JP SEND
NUM_P:
        LD A,$38
        JP SEND
LOWER_P:
        LD A,$70
        JP SEND
KEY_Q:
        BIT 6,(HL)
        JR Z,NUM_Q
        BIT 5,(HL)
        JR Z,LOWER_Q
        LD A,$51
        JP SEND
NUM_Q:
        LD A,$39
        JP SEND
LOWER_Q:
        LD A,$71
        JP SEND
KEY_R:
        BIT 6,(HL)
        JR Z,NUM_R
        BIT 5,(HL)
        JR Z,LOWER_R
        LD A,$52
        JP SEND
NUM_R:
        LD A,$2A
        JP SEND
LOWER_R:
        LD A,$72
        JP SEND
KEY_S:
        BIT 5,(HL)
        JR Z,LOWER_S
        LD A,$53
        JP SEND
LOWER_S:
        LD A,$73
        JP SEND
KEY_T:
        BIT 6,(HL)
        JR Z,NUM_T
        BIT 5,(HL)
        JR Z,LOWER_T
        LD A,$54
        JP SEND
NUM_T:
        LD A,$34
        JP SEND
LOWER_T:
        LD A,$74
        JP SEND
KEY_U:
        BIT 6,(HL)
        JR Z,NUM_U
        BIT 5,(HL)
        JR Z,LOWER_U
        LD A,$55
        JP SEND
NUM_U:
        LD A,$35
        JP SEND
LOWER_U:
        LD A,$75
        JP SEND
KEY_V:
        BIT 6,(HL)
        JR Z,NUM_V
        BIT 5,(HL)
        JR Z,LOWER_V
        LD A,$56
        JP SEND
NUM_V:
        LD A,$36
        JP SEND
LOWER_V:
        LD A,$76
        JP SEND
KEY_W:
        BIT 6,(HL)
        JR Z,NUM_W
        BIT 5,(HL)
        JR Z,LOWER_W
        LD A,$57
        JP SEND
NUM_W:
        LD A,$2D
        JP SEND
LOWER_W:
        LD A,$77
        JP SEND
KEY_X:
        BIT 6,(HL)
        JR Z,NUM_X
        BIT 5,(HL)
        JR Z,LOWER_X
        LD A,$58
        JP SEND
NUM_X:
        LD A,$3D
        JP SEND
LOWER_X:
        LD A,$78
        JP SEND
KEY_Y:
        BIT 6,(HL)
        JR Z,NUM_Y
        BIT 5,(HL)
        JR Z,LOWER_Y
        LD A,$59
        JP SEND
NUM_Y:
        LD A,$31
        JP SEND
LOWER_Y:
        LD A,$79
        JP SEND
KEY_Z:
        BIT 6,(HL)
        JR Z,NUM_Z
        BIT 5,(HL)
        JR Z,LOWER_Z
        LD A,$5A
        JP SEND
NUM_Z:
        LD A,$32
        JP SEND
LOWER_Z:
        LD A,$7A
        JP SEND
KEY_EXCLAMATION:
        BIT 6,(HL)
        JR Z,NUM_EXCLAMATION
        LD A,$21
        JP SEND
NUM_EXCLAMATION:
        LD A,$33
        JP SEND
KEY_QUOTES:
        BIT 6,(HL)
        JR Z,NUM_QUOTES
        LD A,$22
        JP SEND
NUM_QUOTES:
        LD A,$2B
        JP SEND
KEY_SPACE:
        BIT 6,(HL)
        JR Z,NUM_SPACE
        LD A,$20
        JP SEND
NUM_SPACE:
        LD A,$30
        JP SEND
KEY_COLON:
        BIT 6,(HL)
        JR Z,NUM_COLON
        LD A,$3A
        JP SEND
NUM_COLON:
        LD A,$2E
        JP SEND
KEY_QUESTION:
        BIT 6,(HL)
        JR Z,NUM_QUESTION
        LD A,$3F
        JP SEND
NUM_QUESTION:
        LD A,$5F
        JP SEND
CALL_NEWLINE:
        LD A,(CURSOR_Y)
        ADD A,6
        LD (CURSOR_Y),A
        LD HL,CURSOR_X
        LD (HL),0
        RET
JUMP_NEWLINE:
        LD A,(CURSOR_Y)
        ADD A,6
        LD (CURSOR_Y),A
        LD HL,CURSOR_X
        LD (HL),0
        JP TERM_WAIT
BACKSPACE:
        LD A,(CURSOR_X)
        SUB 4
        LD (CURSOR_X),A
        JP TERM_WAIT
CLEAR:
        ROM_CALL(CLEARLCD)
        LD HL,$0000
        LD (CURSOR_X),HL
        JP TERM_WAIT
SEND:
        PUSH AF
        CALL SEND_BYTE
        POP AF
        LD HL,TEXT_MEM
        BIT 7,(HL)
        JP Z,TERM_WAIT
PRINT_CHAR:
        PUSH AF
        LD A,(CURSOR_Y)
        CP $36
        CALL NC,SCRNFULL
        LD A,(CURSOR_X)
        CP 90
        CALL NC,CALL_NEWLINE
        POP AF
        ROM_CALL(M_CHARPUT)
        JP TERM_WAIT
SCRNFULL:
        ROM_CALL(CLEARLCD)
        LD HL,$0000
        LD (CURSOR_X),HL
        RET               
SETTINGS:
        ROM_CALL(CLEARLCD)
        LD HL,$0000
        LD (CURSOR_ROW),HL
        LD HL,STRING_SETTINGS
        SET 3,(IY+05)
        ROM_CALL(D_ZT_STR)
        LD HL,$0002
        LD (CURSOR_ROW),HL
        LD HL,STRING_SETTINGS_MENU
        RES 3,(IY+05)
        ROM_CALL(D_ZT_STR)
        LD HL,$0A02
        LD (CURSOR_ROW),HL
        LD HL,TEXT_MEM
        BIT 7,(HL)
        CALL Z,PRINT_OFF
        CALL NZ,PRINT_ON
        ROM_CALL(D_ZT_STR)
SETTINGS_WAIT:
        CALL GET_KEY
        CP G_MODE
        JP Z,MENU
        CP G_1
        JR Z,ECHO
        CP G_2
        JP Z,MENU
        JR SETTINGS_WAIT
ECHO:
        LD HL,TEXT_MEM
        BIT 7,(HL)
        JR Z,ECHO_ON
ECHO_OFF:
        RES 7,(HL)
        JR SETTINGS
ECHO_ON:
        SET 7,(HL)
        JR SETTINGS
PRINT_OFF:
        LD HL,STRING_OFF
        RET
PRINT_ON:
        LD HL,STRING_ON
        RET

#INCLUDE "LINKPORT.H"

STRING_TITLE:
        .DB "   RTerm v0.4   ",0
STRING_AUTHOR:
        .DB "by: Randy Gluvna",0
STRING_MENU:
        .DB "1: Terminal Mode"
        .DB "2: Settings     "
        .DB "3: Quit",0
STRING_SETTINGS:
        .DB "    Settings    ",0
STRING_SETTINGS_MENU:
        .DB "1: Echo -       "
        .DB "2: Quit",0
STRING_OFF:
        .DB "Off",0
STRING_ON:
        .DB "On ",0

.END
